MetaSoul

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
UESBlueprintLibrary Class Reference

`#include <ESBlueprintLibrary.h>`

Inheritance diagram for UESBlueprintLibrary:

## Public Member Functions
| UFUNCTION (BlueprintPure, meta=(DisplayName="To String (Bytes)", BlueprintAutocast), Category="CoreUtility|Conversion") static FString Conv_BytesToString(const TArray< uint8 > &InBytes)
| UFUNCTION (BlueprintPure, meta=(DisplayName="To Bytes (String)", BlueprintAutocast), Category="CoreUtility|Conversion") static TArray< uint8 > Conv_StringToBytes(FString InString)
| UFUNCTION (BlueprintPure, meta=(DisplayName="To Texture2D (Bytes)", BlueprintAutocast), Category="CoreUtility|Conversion") static UTexture2D *Conv_BytesToTexture(const TArray< uint8 > &InBytes)
| UFUNCTION (BlueprintPure, meta=(DisplayName="To Wav Bytes (Opus Bytes)", BlueprintAutocast), Category="CoreUtility|Conversion") static TArray< uint8 > Conv_OpusBytesToWav(const TArray< uint8 > &InBytes)
| UFUNCTION (BlueprintPure, meta=(DisplayName="To Opus Bytes (Wav Bytes)", BlueprintAutocast), Category="CoreUtility|Conversion") static TArray< uint8 > Conv_WavBytesToOpus(const TArray< uint8 > &InBytes)
| UFUNCTION (BlueprintPure, meta=(DisplayName="To SoundWave (Wav Bytes)", BlueprintAutocast), Category="CoreUtility|Conversion") static USoundWave *Conv_WavBytesToSoundWave(const TArray< uint8 > &InBytes)
| UFUNCTION (BlueprintPure, meta=(DisplayName="To Bytes (SoundWave)", BlueprintAutocast), Category="CoreUtility|Conversion") static TArray< uint8 > Conv_SoundWaveToWavBytes(USoundWave *SoundWave)
| UFUNCTION (BlueprintPure, meta=(DisplayName="To Transforms (Bytes)", BlueprintAutocast), Category="CoreUtility|Conversion") static void Conv_CompactBytesToTransforms(const TArray< uint8 > &InCompactBytes
| UFUNCTION (BlueprintPure, meta=(DisplayName="To Transforms (Location Bytes)", BlueprintAutocast), Category="CoreUtility|Conversion") static void Conv_CompactPositionBytesToTransforms(const TArray< uint8 > &InCompactBytes
| UFUNCTION (BlueprintPure, meta=(DisplayName="To Bytes (Texture2D)", BlueprintAutocast), Category="CoreUtility|Conversion") static bool Conv_TextureToBytes(UTexture2D *Texture

## Static Public Member Functions
static void | SetSoundWaveFromWavBytes (USoundWaveProcedural *InSoundWave, const TArray< uint8 > &InBytes)
static TFuture< UTexture2D * > | Conv_BytesToTexture_Async (const TArray< uint8 > &InBytes)
static FString | NowUTCString ()
static FString | GetLoginId ()
static int32 | ToHashCode (const FString &String)
static void | MeasureTimerStart (const FString &Category=TEXT("TimeTaken"))
static float | MeasureTimerStop (const FString &Category=TEXT("TimeTaken"), bool bShouldLogResult=true)
static void | CallFunctionOnThread (const FString &Function, ESIOCallbackType ThreadType, UObject *WorldContextObject=nullptr)
static void | CallFunctionOnThreadGraphReturn (const FString &Function, ESIOCallbackType ThreadType, struct FLatentActionInfo LatentInfo, UObject *WorldContextObject=nullptr)

## Public Attributes
TArray< FTransform > & | OutTransforms
TArray< uint8 > & | OutBuffer
TArray< uint8 > EImageFormatBPType | Format = EImageFormatBPType::PNG)

## Member Function Documentation

## ◆ CallFunctionOnThread()

void UESBlueprintLibrary::CallFunctionOnThread | ( | const FString & | Function,
|  | ESIOCallbackType | ThreadType,
|  | UObject * | WorldContextObject = nullptr )
| static

Calls function by name given calling context on thread specified. Use e.g. delay (0) to return to game thread or use game thread callback for threadtype. This allows you to run certain functions on a background thread or taskgraph in blueprints. Keep in mind that you should not create or destroy UObjects non-game threads.

## ◆ CallFunctionOnThreadGraphReturn()

void UESBlueprintLibrary::CallFunctionOnThreadGraphReturn | ( | const FString & | Function,
|  | ESIOCallbackType | ThreadType,
|  | struct FLatentActionInfo | LatentInfo,
|  | UObject * | WorldContextObject = nullptr )
| static

Calls specified function on thread type with a latent graph return. This allows you to run certain functions on a background thread or taskgraph in blueprints. Keep in mind that you should not create or destroy UObjects non-game threads.

## ◆ Conv_BytesToTexture_Async()

TFuture< UTexture2D * > UESBlueprintLibrary::Conv_BytesToTexture_Async | ( | const TArray< uint8 > & | InBytes | ) |
| static

Fully Async texture conversion from bytes will auto-detect format, depends on TFuture, cannot be called in blueprint. Latent graph callback may be used

## ◆ GetLoginId()

FString UESBlueprintLibrary::GetLoginId | ( |  | ) |
| static

Returns a type of Unique Hardware ID

## ◆ MeasureTimerStart()

void UESBlueprintLibrary::MeasureTimerStart | ( | const FString & | Category = TEXT("TimeTaken") | ) |
| static

Time inter-tick durations for simple

## ◆ MeasureTimerStop()

float UESBlueprintLibrary::MeasureTimerStop | ( | const FString & | Category = TEXT("TimeTaken"),
|  | bool | bShouldLogResult = true )
| static

Stops the timer started for this category and returns the duration taken in milliseconds

## ◆ NowUTCString()

FString UESBlueprintLibrary::NowUTCString | ( |  | ) |
| static

Current UTC time in string format

## ◆ SetSoundWaveFromWavBytes()

void UESBlueprintLibrary::SetSoundWaveFromWavBytes | ( | USoundWaveProcedural * | InSoundWave,
|  | const TArray< uint8 > & | InBytes )
| static

Sets and updates soundwave if needed from incoming bytes. Callable on background threads

## ◆ ToHashCode()

int32 UESBlueprintLibrary::ToHashCode | ( | const FString & | String | ) |
| static

Return a somewhat unique int for given string

## ◆ UFUNCTION() [1/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName="To Bytes (SoundWave)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" )

convert a soundwave into wav bytes

## ◆ UFUNCTION() [2/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName="To Bytes (String)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" )

Convert string to UTF8 bytes

## ◆ UFUNCTION() [3/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName = "To Bytes (Texture2D)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" )

Convert UTexture2D to bytes in given format - can have performance implication

## ◆ UFUNCTION() [4/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName="To Opus Bytes (Wav Bytes)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" ) const &

Audio decompression - Convert wav to opus (currently raw serialized)

## ◆ UFUNCTION() [5/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName="To SoundWave (Wav Bytes)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" ) const &

Assumes .wav chunks - handles async alloc, callable from any thread

## ◆ UFUNCTION() [6/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName="To String (Bytes)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" ) const &

Convert any unicode bytes to string

## ◆ UFUNCTION() [7/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName="To Texture2D (Bytes)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" ) const &

Convert bytes to UTexture2D using auto-detection - optimized, but can still have performance implication

## ◆ UFUNCTION() [8/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName = "To Transforms (Bytes)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" ) const &

Compact Transform bytes are [[pitch,yaw,roll,x,y,z,sx,sy,sz],...]

## ◆ UFUNCTION() [9/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName = "To Transforms (Location Bytes)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" ) const &

Compact Position bytes are [[x,y,z],...]

## ◆ UFUNCTION() [10/10]

UESBlueprintLibrary::UFUNCTION | ( | BlueprintPure | ,
|  | meta | = (DisplayName="To Wav Bytes (Opus Bytes)", BlueprintAutocast),
|  | Category | = "CoreUtility|Conversion" ) const &

Audio compression - Convert opus (currently raw serialized) to pcm

## Member Data Documentation

## ◆ Format

TArray<uint8> EImageFormatBPType UESBlueprintLibrary::Format = EImageFormatBPType::PNG)

## ◆ OutBuffer

TArray<uint8>& UESBlueprintLibrary::OutBuffer

## ◆ OutTransforms

TArray< FTransform > & UESBlueprintLibrary::OutTransforms

The documentation for this class was generated from the following files:

- EmoShapeWebUtility/Public/ESBlueprintLibrary.h
- EmoShapeWebUtility/Private/ESBlueprintLibrary.cpp